%options parent_saved,ast_directory=./ast,ast_type=ASTNode,automatic_ast=toplevel,variables=nt,visitor=default,states
%options programming_language=java
%options package=com.ibm.adt.ovf.ext.punit
%options template=dtParserTemplateD.g
%options import_terminals=PUnitLexer.g
%options la=2
--%options parent_saved,automatic_ast=toplevel,visitor=preorder,ast_directory=./Ast,ast_type=ASTNode

%Globals
    /.
    ./
%End

%Ast
/.
public void acceptAll(IAstVisitor v) {
	accept((Visitor)v);
	for(java.util.Iterator itr = getChildren().iterator(); itr.hasNext();) {
		Object obj = itr.next();
		ASTNode c = (ASTNode) obj;
		if(v.preVisit(this)) {
			c.accept((Visitor)v);
			c.acceptAll(v);
			v.postVisit(this);
		}			
	}
}
./	
%End
 
%Start
    ProgrammaticUnit
%End

%Rules
    ProgrammaticUnit ::= %empty
                         | BaseUnit Terms 

    Terms ::= %empty | Terms OptionalWS Term
    
    Term ::= MultipliedBaseUnit | DividedBaseUnit | Modifier1 | Modifier2
    
    MultipliedBaseUnit ::= TIMES OptionalWS BaseUnit
    
    DividedBaseUnit ::= DIVIDE OptionalWS BaseUnit
    
    Modifier1 ::= Operator  OptionalWS Number

    Modifier2 ::= Operator OptionalWS Base OptionalWS HAT OptionalWS Exponent
    
    PositiveNumber ::= INT
                       | INT DOT INT
    Number ::= PositiveNumber
               | PLUS PositiveNumber                                      
               | MINUS PositiveNumber
               
    Base ::= INT
    
    Exponent ::= INT | PLUS INT | MINUS INT
    
    Operator ::= TIMES | DIVIDE
    
    BaseUnit ::= SimpleName | CountedOrDecibelBaseUnit  -- decibel-base-unit is a subcase of CountedBaseUnit
    
    SimpleName ::= IDENTIFIER
    
    SimpleName ::= SimpleName SPACE IDENTIFIER
    
    CountedOrDecibelBaseUnit ::= SimpleName -- must be "count" or "decibel"
                        OptionalSpace LEFTPAREN OptionalSpace WhatsCounted OptionalSpace RIGHTPAREN

    Lpar ::= LEFTPAREN
    
    Rpar ::= RIGHTPAREN
    
    WhatsCounted ::= SimpleName
                     | SimpleName OptionalSpace Lpar WhatsCounted OptionalSpace Rpar                         
                        
    OptionalSpace ::= %empty | SPACE                        

    OptionalWS ::= %empty | SPACE | OTHERWS
    
%End

%Headers
    /.
    ./
%End
