%options parent_saved,ast_directory=./ast,ast_type=ASTNode,automatic_ast=toplevel,variables=nt,visitor=default,states
%options programming_language=java
%options package=com.ibm.adt.ovf.ext.qualifier
%options template=dtParserTemplateD.g
%options import_terminals=QualifierLexer.g
%options la=2
--%options parent_saved,automatic_ast=toplevel,visitor=preorder,ast_directory=./Ast,ast_type=ASTNode

%Globals
    /.
    ./
%End

%Ast
/.
public void acceptAll(IAstVisitor v) {
	accept((Visitor)v);
	for(java.util.Iterator itr = getChildren().iterator(); itr.hasNext();) {
		Object obj = itr.next();
		ASTNode c = (ASTNode) obj;
		if(v.preVisit(this)) {
			c.accept((Visitor)v);
			c.acceptAll(v);
			v.postVisit(this);
		}			
	}
}
./	
%End
 
%Start
    QualifierList
%End

%Rules
    QualifierList ::= LBRACKET Qualifiers RBRACKET
    
    Qualifiers ::= Qualifiers COMMA Qualifier
                   | Qualifier
    
    Qualifier ::= QualifierName
                  | QualifierName QualifierParameter
    
    QualifierName ::= IDENTIFIER
    
    QualifierParameter ::= LEFTPAREN ConstantValue RIGHTPAREN
                           | ArrayInitializer

    OptionalSign ::= %empty | PLUS | MINUS
    
    ConstantValue ::= IntegerValue 
                      | RealValue
                      | CharValue
                      | StringValue
                      | BooleanValue
                      | NullValue

    IntegerValue ::= OptionalSign BINARYVALUE
                     | OptionalSign OCTALVALUE
                     | OptionalSign DECIMALVALUE
                     | OptionalSign HEXVALUE
                        
    RealValue ::= OptionalSign REALVALUE
    
    CharValue ::= CHARVALUE
    
    StringValue ::= STRINGFRAG | StringValue STRINGFRAG
    
    BooleanValue ::= TRUE | FALSE
    
    NullValue ::= NULL
    
    ArrayInitializer ::= LBRACE ConstList RBRACE
    
    ConstList ::= ConstantValue
                  | ConstList COMMA ConstantValue
                  
%End

%Headers
    /.
    ./
%End
